'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObjectMapValues = require('lodash/object/mapValues');

var _lodashObjectMapValues2 = _interopRequireDefault(_lodashObjectMapValues);

var _lodashObjectPick = require('lodash/object/pick');

var _lodashObjectPick2 = _interopRequireDefault(_lodashObjectPick);

var _props2 = require('./props');

var _props3 = _interopRequireDefault(_props2);

var _Layout = require('./Layout');

var _Layout2 = _interopRequireDefault(_Layout);

var _Controls = require('./Controls');

var _Controls2 = _interopRequireDefault(_Controls);

var _stringify = require('./stringify');

var _stringify2 = _interopRequireDefault(_stringify);

exports['default'] = _react2['default'].createClass({

  displayName: 'Demo',

  propTypes: {
    props: _react.PropTypes.object,
    fullWidth: _react.PropTypes.bool,
    target: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string]),
    children: _react.PropTypes.func,
    codeIndentDepth: _react.PropTypes.number,
    background: _Layout2['default'].propTypes.background
  },

  statics: { props: _props3['default'] },

  getDefaultProps: function getDefaultProps() {
    return {
      props: {},
      fullWidth: false,
      codeIndentDepth: 3,
      background: 'light'
    };
  },

  getInitialState: function getInitialState() {
    return {
      values: _lodashObjectMapValues2['default'](this.getPropsValue(), function (x) {
        return x.initialValue;
      }),
      logs: _lodashObjectMapValues2['default'](this.getPropsCallback(), function () {
        return [];
      })
    };
  },

  getPropsValue: function getPropsValue() {
    return _lodashObjectPick2['default'](this.props.props, function (x) {
      return x.type === 'value';
    });
  },

  getPropsCallback: function getPropsCallback() {
    return _lodashObjectPick2['default'](this.props.props, function (x) {
      return x.type === 'callback';
    });
  },

  getCallbacks: function getCallbacks() {
    var _this = this;

    return _lodashObjectMapValues2['default'](this.getPropsCallback(), function (x, key) {
      return function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var map = x.map;
        var callbackType = x.callbackType;

        var result = map ? _stringify2['default'](map.apply(undefined, args)) : args.map(_stringify2['default']).join(', ');
        var logs = _this.state.logs;

        var nextLog = callbackType === 'logLatest' ? [result] : [result].concat(logs[key]);
        _this.setState(function (state) {
          var _extends2;

          return { logs: _extends({}, state.logs, (_extends2 = {}, _extends2[key] = nextLog, _extends2)) };
        });
      };
    });
  },

  updateValues: function updateValues(changes) {
    var updater = typeof changes === 'function' ? function (state) {
      return { values: changes(state.values) };
    } : function (state) {
      return { values: _extends({}, state.values, changes) };
    };
    this.setState(updater);
  },

  render: function render() {
    var _state = this.state;
    var values = _state.values;
    var logs = _state.logs;
    var _props = this.props;
    var children = _props.children;
    var fullWidth = _props.fullWidth;
    var codeIndentDepth = _props.codeIndentDepth;
    var background = _props.background;

    var targetProps = _extends({}, values, this.getCallbacks());
    var targetEl = children ? children(targetProps, this.updateValues) : _react2['default'].createElement(this.props.target, targetProps);

    var controlsProps = {
      logs: logs,
      values: values,
      codeIndentDepth: codeIndentDepth,
      targetEl: targetEl,
      onTop: fullWidth,
      props: this.getPropsValue(),
      onChange: this.updateValues
    };
    var controlsEl = _react2['default'].createElement(_Controls2['default'], controlsProps);

    var layoutProps = { fullWidth: fullWidth, targetEl: targetEl, controlsEl: controlsEl, background: background };
    return _react2['default'].createElement(_Layout2['default'], layoutProps);
  }

});
module.exports = exports['default'];